Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/exportappliance/UIWizardExportAppPageExpert.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/exportappliance/UIWizardExportAppPageExpert.h	(revision 78034)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/exportappliance/UIWizardExportAppPageExpert.h	(revision 78037)
@@ -53,5 +53,5 @@
 public:
 
-    /** Constructs expert basic page.
+    /** Constructs expert page.
       * @param  selectedVMNames  Brings the list of selected VM names. */
     UIWizardExportAppPageExpert(const QStringList &selectedVMNames, bool fExportToOCIByDefault);
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/importappliance/UIWizardImportApp.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/importappliance/UIWizardImportApp.cpp	(revision 78034)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/importappliance/UIWizardImportApp.cpp	(revision 78037)
@@ -138,4 +138,9 @@
 };
 
+
+/*********************************************************************************************************************************
+*   Class UIWizardImportApp implementation.                                                                                      *
+*********************************************************************************************************************************/
+
 UIWizardImportApp::UIWizardImportApp(QWidget *pParent, const QString &strFileName)
     : UIWizard(pParent, WizardType_ImportAppliance)
@@ -151,4 +156,31 @@
 }
 
+void UIWizardImportApp::prepare()
+{
+    /* Create corresponding pages: */
+    switch (mode())
+    {
+        case WizardMode_Basic:
+        {
+            if (m_strFileName.isEmpty())
+                setPage(Page1, new UIWizardImportAppPageBasic1);
+            setPage(Page2, new UIWizardImportAppPageBasic2(m_strFileName));
+            break;
+        }
+        case WizardMode_Expert:
+        {
+            setPage(PageExpert, new UIWizardImportAppPageExpert(m_strFileName));
+            break;
+        }
+        default:
+        {
+            AssertMsgFailed(("Invalid mode: %d", mode()));
+            break;
+        }
+    }
+    /* Call to base-class: */
+    UIWizard::prepare();
+}
+
 bool UIWizardImportApp::isValid() const
 {
@@ -182,4 +214,15 @@
 }
 
+void UIWizardImportApp::retranslateUi()
+{
+    /* Call to base-class: */
+    UIWizard::retranslateUi();
+
+    /* Translate wizard: */
+    setWindowTitle(tr("Import Virtual Appliance"));
+    setButtonText(QWizard::CustomButton2, tr("Restore Defaults"));
+    setButtonText(QWizard::FinishButton, tr("Import"));
+}
+
 void UIWizardImportApp::sltCurrentIdChanged(int iId)
 {
@@ -207,42 +250,4 @@
 }
 
-void UIWizardImportApp::retranslateUi()
-{
-    /* Call to base-class: */
-    UIWizard::retranslateUi();
-
-    /* Translate wizard: */
-    setWindowTitle(tr("Import Virtual Appliance"));
-    setButtonText(QWizard::CustomButton2, tr("Restore Defaults"));
-    setButtonText(QWizard::FinishButton, tr("Import"));
-}
-
-void UIWizardImportApp::prepare()
-{
-    /* Create corresponding pages: */
-    switch (mode())
-    {
-        case WizardMode_Basic:
-        {
-            if (m_strFileName.isEmpty())
-                setPage(Page1, new UIWizardImportAppPageBasic1);
-            setPage(Page2, new UIWizardImportAppPageBasic2(m_strFileName));
-            break;
-        }
-        case WizardMode_Expert:
-        {
-            setPage(PageExpert, new UIWizardImportAppPageExpert(m_strFileName));
-            break;
-        }
-        default:
-        {
-            AssertMsgFailed(("Invalid mode: %d", mode()));
-            break;
-        }
-    }
-    /* Call to base-class: */
-    UIWizard::prepare();
-}
-
 #include "UIWizardImportApp.moc"
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/importappliance/UIWizardImportApp.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/importappliance/UIWizardImportApp.h	(revision 78034)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/importappliance/UIWizardImportApp.h	(revision 78037)
@@ -22,8 +22,8 @@
 #endif
 
-/* Local includes */
+/* GUI includes */
 #include "UIWizard.h"
 
-/* Import Appliance wizard: */
+/** Import Appliance wizard. */
 class UIWizardImportApp : public UIWizard
 {
@@ -32,5 +32,5 @@
 public:
 
-    /* Page IDs: */
+    /** Basic page IDs. */
     enum
     {
@@ -39,5 +39,5 @@
     };
 
-    /* Page IDs: */
+    /** Expert page IDs. */
     enum
     {
@@ -45,40 +45,37 @@
     };
 
-    /* Constructor: */
+    /** Constructs export appliance wizard passing @a pParent to the base-class.
+      * @param  strFileName  Brings appliance file name. */
     UIWizardImportApp(QWidget *pParent, const QString &strFileName);
 
-    /* Pages related stuff: */
-    void prepare();
+    /** Prepares all. */
+    virtual void prepare() /* override */;
 
-    /* Is appliance valid? */
+    /** Returns whether appliance is valid. */
     bool isValid() const;
+
+    /** Imports appliance. */
+    bool importAppliance();
 
 protected:
 
-    /* Import stuff: */
-    bool importAppliance();
+    /** Handles translation event. */
+    virtual void retranslateUi() /* override */;
 
-    /* Who will be able to import appliance: */
-    friend class UIWizardImportAppPageBasic2;
-    friend class UIWizardImportAppPageExpert;
+protected slots:
 
-private slots:
-
-    /* Page change handler: */
-    void sltCurrentIdChanged(int iId);
-    /* Custom button 2 click handler: */
-    void sltCustomButtonClicked(int iId);
+    /** Handles change for page with @a iId. */
+    virtual void sltCurrentIdChanged(int iId) /* override */;
+    /** Handles custom button 2 click  for page with @a iId. */
+    virtual void sltCustomButtonClicked(int iId) /* override */;
 
 private:
 
-    /* Translation stuff: */
-    void retranslateUi();
-
-    /* Variables: */
-    QString m_strFileName;
+    /** Handles the appliance file name. */
+    QString  m_strFileName;
 };
 
+/** Safe pointer to appliance wizard. */
 typedef QPointer<UIWizardImportApp> UISafePointerWizardImportApp;
 
 #endif /* !FEQT_INCLUDED_SRC_wizards_importappliance_UIWizardImportApp_h */
-
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/importappliance/UIWizardImportAppDefs.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/importappliance/UIWizardImportAppDefs.h	(revision 78034)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/importappliance/UIWizardImportAppDefs.h	(revision 78037)
@@ -22,9 +22,9 @@
 #endif
 
-/* Global includes: */
+/* Qt includes: */
 #include <QMetaType>
 #include <QPointer>
 
-/* Local includes: */
+/* GUI includes: */
 #include "UIApplianceImportEditorWidget.h"
 
@@ -34,3 +34,2 @@
 
 #endif /* !FEQT_INCLUDED_SRC_wizards_importappliance_UIWizardImportAppDefs_h */
-
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/importappliance/UIWizardImportAppPageBasic1.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/importappliance/UIWizardImportAppPageBasic1.cpp	(revision 78034)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/importappliance/UIWizardImportAppPageBasic1.cpp	(revision 78037)
@@ -16,16 +16,20 @@
  */
 
-/* Global includes: */
+/* Qt includes: */
 #include <QFileInfo>
 #include <QVBoxLayout>
 
-/* Local includes: */
+/* GUI includes: */
+#include "QIRichTextLabel.h"
+#include "VBoxGlobal.h"
+#include "UIEmptyFilePathSelector.h"
+#include "UIWizardImportApp.h"
 #include "UIWizardImportAppPageBasic1.h"
 #include "UIWizardImportAppPageBasic2.h"
-#include "UIWizardImportApp.h"
-#include "VBoxGlobal.h"
-#include "UIEmptyFilePathSelector.h"
-#include "QIRichTextLabel.h"
 
+
+/*********************************************************************************************************************************
+*   Class UIWizardImportAppPage1 implementation.                                                                                 *
+*********************************************************************************************************************************/
 
 UIWizardImportAppPage1::UIWizardImportAppPage1()
@@ -33,11 +37,26 @@
 }
 
+
+/*********************************************************************************************************************************
+*   Class UIWizardImportAppPageBasic1 implementation.                                                                            *
+*********************************************************************************************************************************/
+
 UIWizardImportAppPageBasic1::UIWizardImportAppPageBasic1()
 {
-    /* Create widgets: */
+    /* Create main layout: */
     QVBoxLayout *pMainLayout = new QVBoxLayout(this);
+    if (pMainLayout)
     {
+        /* Create label: */
         m_pLabel = new QIRichTextLabel(this);
+        if (m_pLabel)
+        {
+            /* Add into layout: */
+            pMainLayout->addWidget(m_pLabel);
+        }
+
+        /* Create file-path selector: */
         m_pFileSelector = new UIEmptyFilePathSelector(this);
+        if (m_pFileSelector)
         {
             m_pFileSelector->setHomeDir(vboxGlobal().documentsPath());
@@ -45,7 +64,10 @@
             m_pFileSelector->setButtonPosition(UIEmptyFilePathSelector::RightPosition);
             m_pFileSelector->setEditable(true);
+
+            /* Add into layout: */
+            pMainLayout->addWidget(m_pFileSelector);
         }
-        pMainLayout->addWidget(m_pLabel);
-        pMainLayout->addWidget(m_pFileSelector);
+
+        /* Add vertical stretch finally: */
         pMainLayout->addStretch();
     }
@@ -71,5 +93,4 @@
 void UIWizardImportAppPageBasic1::initializePage()
 {
-    /* Translate page: */
     retranslateUi();
 }
@@ -78,6 +99,6 @@
 {
     /* Make sure appliance file has allowed extension and exists: */
-    return VBoxGlobal::hasAllowedExtension(m_pFileSelector->path().toLower(), OVFFileExts) &&
-           QFile::exists(m_pFileSelector->path());
+    return    VBoxGlobal::hasAllowedExtension(m_pFileSelector->path().toLower(), OVFFileExts)
+           && QFile::exists(m_pFileSelector->path());
 }
 
@@ -101,3 +122,2 @@
     return pImportApplianceWidget->isValid();
 }
-
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/importappliance/UIWizardImportAppPageBasic1.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/importappliance/UIWizardImportAppPageBasic1.h	(revision 78034)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/importappliance/UIWizardImportAppPageBasic1.h	(revision 78037)
@@ -22,24 +22,24 @@
 #endif
 
-/* Local includes: */
+/* GUI includes: */
 #include "UIWizardPage.h"
 
 /* Forward declarations: */
+class QIRichTextLabel;
 class UIEmptyFilePathSelector;
-class QIRichTextLabel;
 
-/* 1st page of the Import Appliance wizard (base part): */
+/** UIWizardPageBase extension for 1st page of the Import Appliance wizard. */
 class UIWizardImportAppPage1 : public UIWizardPageBase
 {
 protected:
 
-    /* Constructor: */
+    /** Constructs 1st page base. */
     UIWizardImportAppPage1();
 
-    /* Widgets: */
+    /** Holds the file selector instance. */
     UIEmptyFilePathSelector *m_pFileSelector;
 };
 
-/* 1st page of the Import Appliance wizard (basic extension): */
+/** UIWizardPage extension for 1st page of the Import Appliance wizard, extends UIWizardImportAppPage1 as well. */
 class UIWizardImportAppPageBasic1 : public UIWizardPage, public UIWizardImportAppPage1
 {
@@ -48,23 +48,24 @@
 public:
 
-    /* Constructor: */
+    /** Constructs 1st basic page. */
     UIWizardImportAppPageBasic1();
 
 private:
 
-    /* Translate stuff: */
-    void retranslateUi();
+    /** Handles translation event. */
+    virtual void retranslateUi() /* override */;
 
-    /* Prepare stuff: */
-    void initializePage();
+    /** Performs page initialization. */
+    virtual void initializePage() /* override */;
 
-    /* Validation stuff: */
-    bool isComplete() const;
-    bool validatePage();
+    /** Returns whether page is complete. */
+    virtual bool isComplete() const /* override */;
 
-    /* Widgets: */
+    /** Performs page validation. */
+    virtual bool validatePage() /* override */;
+
+    /** Holds the label instance. */
     QIRichTextLabel *m_pLabel;
 };
 
 #endif /* !FEQT_INCLUDED_SRC_wizards_importappliance_UIWizardImportAppPageBasic1_h */
-
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/importappliance/UIWizardImportAppPageBasic2.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/importappliance/UIWizardImportAppPageBasic2.cpp	(revision 78034)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/importappliance/UIWizardImportAppPageBasic2.cpp	(revision 78037)
@@ -16,5 +16,5 @@
  */
 
-/* Global includes: */
+/* Qt includes: */
 #include <QLabel>
 #include <QPointer>
@@ -23,5 +23,5 @@
 #include <QVBoxLayout>
 
-/* Local includes: */
+/* GUI includes: */
 #include "QIDialogButtonBox.h"
 #include "QIRichTextLabel.h"
@@ -50,17 +50,33 @@
     : m_enmCertText(kCertText_Uninitialized)
 {
-    /* Create widgets: */
+    /* Create main layout: */
     QVBoxLayout *pMainLayout = new QVBoxLayout(this);
-    {
+    if (pMainLayout)
+    {
+        /* Create label: */
         m_pLabel = new QIRichTextLabel(this);
+        if (m_pLabel)
+        {
+            /* Add into layout: */
+            pMainLayout->addWidget(m_pLabel);
+        }
+
+        /* Create appliance widget: */
         m_pApplianceWidget = new UIApplianceImportEditorWidget(this);
         {
             m_pApplianceWidget->setSizePolicy(QSizePolicy::Preferred, QSizePolicy::MinimumExpanding);
             m_pApplianceWidget->setFile(strFileName);
-        }
+
+            /* Add into layout: */
+            pMainLayout->addWidget(m_pApplianceWidget);
+        }
+
+        /* Create certificate label: */
         m_pCertLabel = new QLabel("<cert label>", this);
-        pMainLayout->addWidget(m_pLabel);
-        pMainLayout->addWidget(m_pApplianceWidget);
-        pMainLayout->addWidget(m_pCertLabel);
+        if (m_pCertLabel)
+        {
+            /* Add into layout: */
+            pMainLayout->addWidget(m_pCertLabel);
+        }
     }
 
@@ -115,8 +131,9 @@
 void UIWizardImportAppPageBasic2::initializePage()
 {
-    /* Acquire appliance and certificate: */
+    /* Acquire appliance: */
     CAppliance *pAppliance = m_pApplianceWidget->appliance();
-    /* Check if pAppliance is alive. If not just return here. This
-       prevents crashes when an invalid ova file is supllied: */
+
+    /* Check if pAppliance is alive. If not just return here.
+     * This prevents crashes when an invalid ova file is supllied: */
     if (!pAppliance)
     {
@@ -125,24 +142,26 @@
         return;
     }
-    CCertificate certificate = pAppliance->GetCertificate();
-    if (certificate.isNull())
+
+    /* Acquire certificate: */
+    CCertificate comCertificate = pAppliance->GetCertificate();
+    if (comCertificate.isNull())
         m_enmCertText = kCertText_Unsigned;
     else
     {
-        /* Pick a 'signed-by' name. */
-        m_strSignedBy = certificate.GetFriendlyName();
+        /* Pick a 'signed-by' name: */
+        m_strSignedBy = comCertificate.GetFriendlyName();
 
         /* If trusted, just select the right message: */
-        if (certificate.GetTrusted())
-        {
-            if (certificate.GetSelfSigned())
-                m_enmCertText = !certificate.GetExpired() ? kCertText_SelfSignedTrusted : kCertText_SelfSignedExpired;
+        if (comCertificate.GetTrusted())
+        {
+            if (comCertificate.GetSelfSigned())
+                m_enmCertText = !comCertificate.GetExpired() ? kCertText_SelfSignedTrusted : kCertText_SelfSignedExpired;
             else
-                m_enmCertText = !certificate.GetExpired() ? kCertText_IssuedTrusted     : kCertText_IssuedExpired;
+                m_enmCertText = !comCertificate.GetExpired() ? kCertText_IssuedTrusted     : kCertText_IssuedExpired;
         }
         else
         {
             /* Not trusted!  Must ask the user whether to continue in this case: */
-            m_enmCertText = certificate.GetSelfSigned() ? kCertText_SelfSignedUnverified : kCertText_IssuedUnverified;
+            m_enmCertText = comCertificate.GetSelfSigned() ? kCertText_SelfSignedUnverified : kCertText_IssuedUnverified;
 
             /* Translate page early: */
@@ -150,5 +169,5 @@
 
             /* Instantiate the dialog: */
-            QPointer<UIApplianceUnverifiedCertificateViewer> pDialog = new UIApplianceUnverifiedCertificateViewer(this, certificate);
+            QPointer<UIApplianceUnverifiedCertificateViewer> pDialog = new UIApplianceUnverifiedCertificateViewer(this, comCertificate);
             AssertPtrReturnVoid(pDialog.data());
 
@@ -161,5 +180,4 @@
             /* Delete viewer finally: */
             delete pDialog;
-            pDialog = 0;
 
             /* Dismiss the entire import-appliance wizard if user rejects certificate: */
@@ -205,11 +223,10 @@
 *********************************************************************************************************************************/
 
-UIApplianceUnverifiedCertificateViewer::UIApplianceUnverifiedCertificateViewer(QWidget *pParent, const CCertificate &certificate)
+UIApplianceUnverifiedCertificateViewer::UIApplianceUnverifiedCertificateViewer(QWidget *pParent, const CCertificate &comCertificate)
     : QIWithRetranslateUI<QIDialog>(pParent)
-    , m_certificate(certificate)
+    , m_comCertificate(comCertificate)
     , m_pTextLabel(0)
     , m_pTextBrowser(0)
 {
-    /* Prepare: */
     prepare();
 }
@@ -219,13 +236,13 @@
     /* Create layout: */
     QVBoxLayout *pLayout = new QVBoxLayout(this);
-    AssertPtrReturnVoid(pLayout);
+    if (pLayout)
     {
         /* Create text-label: */
         m_pTextLabel = new QLabel;
-        AssertPtrReturnVoid(m_pTextLabel);
-        {
-            /* Configure text-label: */
+        if (m_pTextLabel)
+        {
             m_pTextLabel->setWordWrap(true);
-            /* Add text-label into layout: */
+
+            /* Add into layout: */
             pLayout->addWidget(m_pTextLabel);
         }
@@ -233,9 +250,9 @@
         /* Create text-browser: */
         m_pTextBrowser = new QTextBrowser;
-        AssertPtrReturnVoid(m_pTextBrowser);
-        {
-            /* Configure text-browser: */
+        if (m_pTextBrowser)
+        {
             m_pTextBrowser->setMinimumSize(500, 300);
-            /* Add text-browser into layout: */
+
+            /* Add into layout: */
             pLayout->addWidget(m_pTextBrowser);
         }
@@ -243,7 +260,6 @@
         /* Create button-box: */
         QIDialogButtonBox *pButtonBox = new QIDialogButtonBox;
-        AssertPtrReturnVoid(pButtonBox);
-        {
-            /* Configure button-box: */
+        if (pButtonBox)
+        {
             pButtonBox->setStandardButtons(QDialogButtonBox::Yes | QDialogButtonBox::No);
             pButtonBox->button(QDialogButtonBox::Yes)->setShortcut(Qt::Key_Enter);
@@ -251,8 +267,10 @@
             connect(pButtonBox, &QIDialogButtonBox::accepted, this, &UIApplianceUnverifiedCertificateViewer::accept);
             connect(pButtonBox, &QIDialogButtonBox::rejected, this, &UIApplianceUnverifiedCertificateViewer::reject);
-            /* Add button-box into layout: */
+
+            /* Add into layout: */
             pLayout->addWidget(pButtonBox);
         }
     }
+
     /* Translate UI: */
     retranslateUi();
@@ -265,27 +283,27 @@
 
     /* Translate text-label caption: */
-    if (m_certificate.GetSelfSigned())
+    if (m_comCertificate.GetSelfSigned())
         m_pTextLabel->setText(tr("<b>The appliance is signed by an unverified self signed certificate issued by '%1'. "
                                  "We recommend to only proceed with the importing if you are sure you should trust this entity.</b>"
-                                 ).arg(m_certificate.GetFriendlyName()));
+                                 ).arg(m_comCertificate.GetFriendlyName()));
     else
         m_pTextLabel->setText(tr("<b>The appliance is signed by an unverified certificate issued to '%1'. "
                                  "We recommend to only proceed with the importing if you are sure you should trust this entity.</b>"
-                                 ).arg(m_certificate.GetFriendlyName()));
+                                 ).arg(m_comCertificate.GetFriendlyName()));
 
     /* Translate text-browser contents: */
     const QString strTemplateRow = tr("<tr><td>%1:</td><td>%2</td></tr>", "key: value");
     QString strTableContent;
-    strTableContent += strTemplateRow.arg(tr("Issuer"),               QStringList(m_certificate.GetIssuerName().toList()).join(", "));
-    strTableContent += strTemplateRow.arg(tr("Subject"),              QStringList(m_certificate.GetSubjectName().toList()).join(", "));
-    strTableContent += strTemplateRow.arg(tr("Not Valid Before"),     m_certificate.GetValidityPeriodNotBefore());
-    strTableContent += strTemplateRow.arg(tr("Not Valid After"),      m_certificate.GetValidityPeriodNotAfter());
-    strTableContent += strTemplateRow.arg(tr("Serial Number"),        m_certificate.GetSerialNumber());
-    strTableContent += strTemplateRow.arg(tr("Self-Signed"),          m_certificate.GetSelfSigned() ? tr("True") : tr("False"));
-    strTableContent += strTemplateRow.arg(tr("Authority (CA)"),       m_certificate.GetCertificateAuthority() ? tr("True") : tr("False"));
-//    strTableContent += strTemplateRow.arg(tr("Trusted"),              m_certificate.GetTrusted() ? tr("True") : tr("False"));
-    strTableContent += strTemplateRow.arg(tr("Public Algorithm"),     tr("%1 (%2)", "value (clarification)").arg(m_certificate.GetPublicKeyAlgorithm()).arg(m_certificate.GetPublicKeyAlgorithmOID()));
-    strTableContent += strTemplateRow.arg(tr("Signature Algorithm"),  tr("%1 (%2)", "value (clarification)").arg(m_certificate.GetSignatureAlgorithmName()).arg(m_certificate.GetSignatureAlgorithmOID()));
-    strTableContent += strTemplateRow.arg(tr("X.509 Version Number"), QString::number(m_certificate.GetVersionNumber()));
+    strTableContent += strTemplateRow.arg(tr("Issuer"),               QStringList(m_comCertificate.GetIssuerName().toList()).join(", "));
+    strTableContent += strTemplateRow.arg(tr("Subject"),              QStringList(m_comCertificate.GetSubjectName().toList()).join(", "));
+    strTableContent += strTemplateRow.arg(tr("Not Valid Before"),     m_comCertificate.GetValidityPeriodNotBefore());
+    strTableContent += strTemplateRow.arg(tr("Not Valid After"),      m_comCertificate.GetValidityPeriodNotAfter());
+    strTableContent += strTemplateRow.arg(tr("Serial Number"),        m_comCertificate.GetSerialNumber());
+    strTableContent += strTemplateRow.arg(tr("Self-Signed"),          m_comCertificate.GetSelfSigned() ? tr("True") : tr("False"));
+    strTableContent += strTemplateRow.arg(tr("Authority (CA)"),       m_comCertificate.GetCertificateAuthority() ? tr("True") : tr("False"));
+//    strTableContent += strTemplateRow.arg(tr("Trusted"),              m_comCertificate.GetTrusted() ? tr("True") : tr("False"));
+    strTableContent += strTemplateRow.arg(tr("Public Algorithm"),     tr("%1 (%2)", "value (clarification)").arg(m_comCertificate.GetPublicKeyAlgorithm()).arg(m_comCertificate.GetPublicKeyAlgorithmOID()));
+    strTableContent += strTemplateRow.arg(tr("Signature Algorithm"),  tr("%1 (%2)", "value (clarification)").arg(m_comCertificate.GetSignatureAlgorithmName()).arg(m_comCertificate.GetSignatureAlgorithmOID()));
+    strTableContent += strTemplateRow.arg(tr("X.509 Version Number"), QString::number(m_comCertificate.GetVersionNumber()));
     m_pTextBrowser->setText(QString("<table>%1</table>").arg(strTableContent));
 }
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/importappliance/UIWizardImportAppPageBasic2.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/importappliance/UIWizardImportAppPageBasic2.h	(revision 78034)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/importappliance/UIWizardImportAppPageBasic2.h	(revision 78037)
@@ -25,6 +25,6 @@
 #include "QIDialog.h"
 #include "QIWithRetranslateUI.h"
+#include "UIWizardImportAppDefs.h"
 #include "UIWizardPage.h"
-#include "UIWizardImportAppDefs.h"
 
 /* Forward declarations: */
@@ -35,21 +35,20 @@
 class CCertificate;
 
-
-/** 2nd page of the Import Appliance wizard (base part): */
+/** UIWizardPageBase extension for 2nd page of the Import Appliance wizard. */
 class UIWizardImportAppPage2 : public UIWizardPageBase
 {
 protected:
 
-    /* Constructor: */
+    /** Constructs 2nd page base. */
     UIWizardImportAppPage2();
 
-    /* Stuff for 'applianceWidget' field: */
+    /** Returns appliance widget instance. */
     ImportAppliancePointer applianceWidget() const { return m_pApplianceWidget; }
 
-    /* Widgets: */
+    /** Holds the appliance widget instance. */
     ImportAppliancePointer m_pApplianceWidget;
 };
 
-/** 2nd page of the Import Appliance wizard (basic extension): */
+/** UIWizardPage extension for 2nd page of the Import Appliance wizard, extends UIWizardImportAppPage2 as well. */
 class UIWizardImportAppPageBasic2 : public UIWizardPage, public UIWizardImportAppPage2
 {
@@ -59,22 +58,28 @@
 public:
 
-    /* Constructor: */
+    /** Constructs 2nd basic page.
+      * @param  strFileName  Brings appliance file name. */
     UIWizardImportAppPageBasic2(const QString &strFileName);
 
 private:
 
-    /* Translate stuff: */
-    void retranslateUi();
+    /** Handles translation event. */
+    virtual void retranslateUi() /* override */;
 
-    /* Prepare stuff: */
-    void initializePage();
-    void cleanupPage();
+    /** Performs page initialization. */
+    virtual void initializePage() /* override */;
+    /** Performs page cleanup. */
+    virtual void cleanupPage() /* override */;
 
-    /* Validation stuff: */
-    bool validatePage();
+    /** Performs page validation. */
+    virtual bool validatePage() /* override */;
 
-    /* Widgets: */
+    /** Holds the label instance. */
     QIRichTextLabel *m_pLabel;
-    QLabel *m_pCertLabel;       /**< Signature/certificate info label. */
+
+    /** Holds the signature/certificate info label instance. */
+    QLabel *m_pCertLabel;
+
+    /** Holds the certificate text template type. */
     enum {
         kCertText_Uninitialized = 0, kCertText_Unsigned,
@@ -82,4 +87,6 @@
         kCertText_SelfSignedTrusted, kCertText_SelfSignedExpired, kCertText_SelfSignedUnverified
     } m_enmCertText;
+
+    /** Holds the "signed by" information. */
     QString m_strSignedBy;
 };
@@ -94,5 +101,5 @@
 
     /** Constructs appliance @a certificate viewer for passed @a pParent. */
-    UIApplianceUnverifiedCertificateViewer(QWidget *pParent, const CCertificate &certificate);
+    UIApplianceUnverifiedCertificateViewer(QWidget *pParent, const CCertificate &comCertificate);
 
 protected:
@@ -107,8 +114,8 @@
 
     /** Holds the certificate reference. */
-    const CCertificate &m_certificate;
+    const CCertificate &m_comCertificate;
 
     /** Holds the text-label instance. */
-    QLabel *m_pTextLabel;
+    QLabel       *m_pTextLabel;
     /** Holds the text-browser instance. */
     QTextBrowser *m_pTextBrowser;
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/importappliance/UIWizardImportAppPageExpert.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/importappliance/UIWizardImportAppPageExpert.cpp	(revision 78034)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/importappliance/UIWizardImportAppPageExpert.cpp	(revision 78037)
@@ -16,26 +16,29 @@
  */
 
-/* Global includes: */
+/* Qt includes: */
 #include <QFileInfo>
+#include <QGroupBox>
 #include <QVBoxLayout>
-#include <QGroupBox>
 
-/* Local includes: */
+/* GUI includes: */
+#include "VBoxGlobal.h"
+#include "UIApplianceImportEditorWidget.h"
+#include "UIEmptyFilePathSelector.h"
+#include "UIWizardImportApp.h"
 #include "UIWizardImportAppPageExpert.h"
-#include "UIWizardImportApp.h"
-#include "VBoxGlobal.h"
-#include "UIEmptyFilePathSelector.h"
-#include "UIApplianceImportEditorWidget.h"
 
 
 UIWizardImportAppPageExpert::UIWizardImportAppPageExpert(const QString &strFileName)
 {
-    /* Create widgets: */
+    /* Create main layout: */
     QVBoxLayout *pMainLayout = new QVBoxLayout(this);
     {
+        /* Create appliance container: */
         m_pApplianceCnt = new QGroupBox(this);
         {
+            /* Create appliance container layout: */
             QVBoxLayout *pApplianceCntLayout = new QVBoxLayout(m_pApplianceCnt);
             {
+                /* Create file-path selector: */
                 m_pFileSelector = new UIEmptyFilePathSelector(m_pApplianceCnt);
                 {
@@ -44,12 +47,22 @@
                     m_pFileSelector->setButtonPosition(UIEmptyFilePathSelector::RightPosition);
                     m_pFileSelector->setEditable(true);
+                    m_pFileSelector->setPath(strFileName);
+
+                    /* Add into layout: */
+                    pApplianceCntLayout->addWidget(m_pFileSelector);
                 }
-                pApplianceCntLayout->addWidget(m_pFileSelector);
             }
+
+            /* Add into layout: */
+            pMainLayout->addWidget(m_pApplianceCnt);
         }
+
+        /* Create settings container: */
         m_pSettingsCnt = new QGroupBox(this);
         {
+            /* Create settings container layout: */
             QVBoxLayout *pSettingsCntLayout = new QVBoxLayout(m_pSettingsCnt);
             {
+                /* Create appliance widget: */
                 m_pApplianceWidget = new UIApplianceImportEditorWidget(m_pSettingsCnt);
                 {
@@ -57,11 +70,13 @@
                     m_pApplianceWidget->setSizePolicy(QSizePolicy::Preferred, QSizePolicy::MinimumExpanding);
                     m_pApplianceWidget->setFile(strFileName);
+
+                    /* Add into layout: */
+                    pSettingsCntLayout->addWidget(m_pApplianceWidget);
                 }
-                pSettingsCntLayout->addWidget(m_pApplianceWidget);
             }
+
+            /* Add into layout: */
+            pMainLayout->addWidget(m_pSettingsCnt);
         }
-        pMainLayout->addWidget(m_pApplianceCnt);
-        pMainLayout->addWidget(m_pSettingsCnt);
-        m_pFileSelector->setPath(strFileName);
     }
 
@@ -78,6 +93,6 @@
 {
     /* Check if set file contains valid appliance: */
-    if (QFile::exists(m_pFileSelector->path()) &&
-        m_pApplianceWidget->setFile(m_pFileSelector->path()))
+    if (   QFile::exists(m_pFileSelector->path())
+        && m_pApplianceWidget->setFile(m_pFileSelector->path()))
     {
         /* Reset the modified bit if file was correctly set: */
@@ -100,5 +115,4 @@
 void UIWizardImportAppPageExpert::initializePage()
 {
-    /* Translate page: */
     retranslateUi();
 }
@@ -107,7 +121,7 @@
 {
     /* Make sure appliance file has allowed extension and exists and appliance widget is valid: */
-    return VBoxGlobal::hasAllowedExtension(m_pFileSelector->path().toLower(), OVFFileExts) &&
-           QFile::exists(m_pFileSelector->path()) &&
-           m_pApplianceWidget->isValid();
+    return    VBoxGlobal::hasAllowedExtension(m_pFileSelector->path().toLower(), OVFFileExts)
+           && QFile::exists(m_pFileSelector->path())
+           && m_pApplianceWidget->isValid();
 }
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/importappliance/UIWizardImportAppPageExpert.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/importappliance/UIWizardImportAppPageExpert.h	(revision 78034)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/importappliance/UIWizardImportAppPageExpert.h	(revision 78037)
@@ -22,5 +22,5 @@
 #endif
 
-/* Local includes: */
+/* GUI includes: */
 #include "UIWizardImportAppPageBasic1.h"
 #include "UIWizardImportAppPageBasic2.h"
@@ -29,5 +29,5 @@
 class QGroupBox;
 
-/* Expert page of the Import Appliance wizard: */
+/** UIWizardPage extension for UIWizardImportAppPage1 and UIWizardImportAppPage2. */
 class UIWizardImportAppPageExpert : public UIWizardPage,
                                     public UIWizardImportAppPage1,
@@ -39,29 +39,32 @@
 public:
 
-    /* Constructor: */
+    /** Constructs expert page.
+      * @param  strFileName  Brings appliance file name. */
     UIWizardImportAppPageExpert(const QString &strFileName);
 
 private slots:
 
-    /* File-path change handler: */
+    /** Handles file-path change. */
     void sltFilePathChangeHandler();
 
 private:
 
-    /* Translate stuff: */
-    void retranslateUi();
+    /** Handles translation event. */
+    virtual void retranslateUi() /* override */;
 
-    /* Prepare stuff: */
-    void initializePage();
+    /** Performs page initialization. */
+    virtual void initializePage() /* override */;
 
-    /* Validation stuff: */
-    bool isComplete() const;
-    bool validatePage();
+    /** Returns whether page is complete. */
+    virtual bool isComplete() const /* override */;
 
-    /* Widgets: */
+    /** Performs page validation. */
+    virtual bool validatePage() /* override */;
+
+    /** Holds the appliance container instance. */
     QGroupBox *m_pApplianceCnt;
+    /** Holds the settings container instance. */
     QGroupBox *m_pSettingsCnt;
 };
 
 #endif /* !FEQT_INCLUDED_SRC_wizards_importappliance_UIWizardImportAppPageExpert_h */
-