Index: trunk/src/VBox/Frontends/VirtualBox/src/globals/UIDialogPanel.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/globals/UIDialogPanel.h	(revision 78088)
+++ trunk/src/VBox/Frontends/VirtualBox/src/globals/UIDialogPanel.h	(revision 78092)
@@ -61,7 +61,7 @@
 
     /** Handles the Qt show @a pEvent. */
-    void showEvent(QShowEvent *pEvent);
+    void showEvent(QShowEvent *pEvent) /* override */;
     /** Handles the Qt hide @a pEvent. */
-    void hideEvent(QHideEvent *pEvent);
+    void hideEvent(QHideEvent *pEvent) /* override */;
     void addVerticalSeparator();
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIFileManager.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIFileManager.cpp	(revision 78088)
+++ trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIFileManager.cpp	(revision 78092)
@@ -413,4 +413,6 @@
         appendLog("Could not find Guest Additions", FileManagerLogType_Error);
         postSessionClosed();
+        if (m_pSessionPanel)
+            m_pSessionPanel->markForError(true);
         return;
     }
@@ -418,7 +420,10 @@
     {
         appendLog("No user name is given", FileManagerLogType_Error);
-        return;
-    }
-    createSession(strUserName, strPassword);
+        if (m_pSessionPanel)
+            m_pSessionPanel->markForError(true);
+        return;
+    }
+    if (m_pSessionPanel)
+        m_pSessionPanel->markForError(!createSession(strUserName, strPassword));
 }
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIFileManagerOperationsPanel.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIFileManagerOperationsPanel.cpp	(revision 78088)
+++ trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIFileManagerOperationsPanel.cpp	(revision 78092)
@@ -338,4 +338,7 @@
         return;
 
+    QPalette mPalette = palette();
+    mPalette.setColor(QPalette::Window, qApp->palette().color(QPalette::Light));
+    setPalette(mPalette);
 
     m_pScrollArea = new QScrollArea;
Index: trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIFileManagerSessionPanel.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIFileManagerSessionPanel.cpp	(revision 78088)
+++ trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIFileManagerSessionPanel.cpp	(revision 78092)
@@ -46,4 +46,5 @@
     /** Makes sure certain widgets are enabled so that a guest session can be created. */
     void switchSessionCloseMode();
+    void markForError(bool fMarkForError);
 
 protected:
@@ -57,4 +58,5 @@
     void sltCreateButtonClick();
     void sltShowHidePassword(bool flag);
+    void sltHandleTextChanged(const QString &strText);
 
 private:
@@ -67,4 +69,7 @@
     QHBoxLayout  *m_pMainLayout;
     QCheckBox    *m_pShowPasswordCheckBox;
+    QColor        m_defaultBaseColor;
+    QColor        m_errorBaseColor;
+    bool          m_fMarkedForError;
 };
 
@@ -82,4 +87,5 @@
     , m_pMainLayout(0)
     , m_pShowPasswordCheckBox(0)
+    , m_fMarkedForError(0)
 {
     prepareWidgets();
@@ -97,4 +103,10 @@
         m_pMainLayout->addWidget(m_pUserNameEdit, 2);
         m_pUserNameEdit->setPlaceholderText(QApplication::translate("UIFileManager", "User Name"));
+        m_defaultBaseColor = m_pUserNameEdit->palette().color(QPalette::Base);
+        m_errorBaseColor = QColor(m_defaultBaseColor.red(),
+                                  0.5 * m_defaultBaseColor.green(),
+                                  0.5 * m_defaultBaseColor.blue());
+        connect(m_pUserNameEdit, &QILineEdit::textChanged,
+                this, &UIGuestSessionCreateWidget::sltHandleTextChanged);
     }
 
@@ -105,4 +117,6 @@
         m_pPasswordEdit->setPlaceholderText(QApplication::translate("UIFileManager", "Password"));
         m_pPasswordEdit->setEchoMode(QLineEdit::Password);
+        connect(m_pPasswordEdit, &QILineEdit::textChanged,
+                this, &UIGuestSessionCreateWidget::sltHandleTextChanged);
     }
 
@@ -148,4 +162,10 @@
     else
         m_pPasswordEdit->setEchoMode(QLineEdit::Password);
+}
+
+void UIGuestSessionCreateWidget::sltHandleTextChanged(const QString &strText)
+{
+    Q_UNUSED(strText);
+    markForError(false);
 }
 
@@ -213,4 +233,30 @@
 }
 
+void UIGuestSessionCreateWidget::markForError(bool fMarkForError)
+{
+    if (m_fMarkedForError == fMarkForError)
+        return;
+    m_fMarkedForError = fMarkForError;
+
+        if (m_pUserNameEdit)
+        {
+            QPalette mPalette = m_pUserNameEdit->palette();
+            if (m_fMarkedForError)
+                mPalette.setColor(QPalette::Base, m_errorBaseColor);
+            else
+                mPalette.setColor(QPalette::Base, m_defaultBaseColor);
+            m_pUserNameEdit->setPalette(mPalette);
+        }
+        if (m_pPasswordEdit)
+        {
+            QPalette mPalette = m_pPasswordEdit->palette();
+            if (m_fMarkedForError)
+                mPalette.setColor(QPalette::Base, m_errorBaseColor);
+            else
+                mPalette.setColor(QPalette::Base, m_defaultBaseColor);
+            m_pPasswordEdit->setPalette(mPalette);
+        }
+}
+
 
 /*********************************************************************************************************************************
@@ -240,4 +286,10 @@
 {
     return "SessionPanel";
+}
+
+void UIFileManagerSessionPanel::markForError(bool fMarkForError)
+{
+    if (m_pSessionCreateWidget)
+        m_pSessionCreateWidget->markForError(fMarkForError);
 }
 
@@ -268,3 +320,9 @@
 }
 
+void UIFileManagerSessionPanel::showEvent(QShowEvent *pEvent)
+{
+    markForError(false);
+    UIDialogPanel::showEvent(pEvent);
+}
+
 #include "UIFileManagerSessionPanel.moc"
Index: trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIFileManagerSessionPanel.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIFileManagerSessionPanel.h	(revision 78088)
+++ trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIFileManagerSessionPanel.h	(revision 78092)
@@ -47,4 +47,5 @@
     /** @} */
     virtual QString panelName() const /* override */;
+    void markForError(bool fMarkForError);
 
 protected:
@@ -53,4 +54,5 @@
     virtual void prepareConnections() /* override */;
     void retranslateUi();
+    void showEvent(QShowEvent *pEvent) /* override */;
 
 private: