Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/importappliance/UIWizardImportAppPageBasic1.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/importappliance/UIWizardImportAppPageBasic1.cpp	(revision 78126)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/importappliance/UIWizardImportAppPageBasic1.cpp	(revision 78127)
@@ -386,7 +386,7 @@
 }
 
-CCloudClient UIWizardImportAppPage1::client() const
-{
-    return m_comCloudClient;
+CVirtualSystemDescriptionForm UIWizardImportAppPage1::vsdForm() const
+{
+    return m_comVSDForm;
 }
 
@@ -619,5 +619,5 @@
     registerField("isSourceCloudOne", this, "isSourceCloudOne");
     registerField("profile", this, "profile");
-    registerField("client", this, "client");
+    registerField("vsdForm", this, "vsdForm");
 }
 
@@ -723,20 +723,52 @@
 bool UIWizardImportAppPageBasic1::validatePage()
 {
-    /* Get import appliance widget: */
-    ImportAppliancePointer pImportApplianceWidget = field("applianceWidget").value<ImportAppliancePointer>();
-    AssertMsg(!pImportApplianceWidget.isNull(), ("Appliance Widget is not set!\n"));
-
-    /* If file name was changed: */
-    if (m_pFileSelector->isModified())
-    {
-        /* Check if set file contains valid appliance: */
-        if (!pImportApplianceWidget->setFile(m_pFileSelector->path()))
+    if (isSourceCloudOne())
+    {
+        CVirtualSystemDescriptionForm comForm;
+        CProgress comProgress = m_comCloudClient.GetExportLaunchDescriptionForm(comForm);
+        /* Show error message if necessary: */
+        if (!m_comCloudClient.isOk())
+        {
+            /// @todo add real error message
+            //msgCenter().cannotAcquireExportLaunchDescriptionForm(comCloudClient, this);
             return false;
-        /* Reset the modified bit afterwards: */
-        m_pFileSelector->resetModified();
-    }
-
-    /* If we have a valid ovf proceed to the appliance settings page: */
-    return pImportApplianceWidget->isValid();
+        }
+        else
+        {
+            /* Show "Acquire export form" progress: */
+            msgCenter().showModalProgressDialog(comProgress, UIWizardImportApp::tr("Acquire export form..."),
+                                                ":/progress_media_move_90px.png", this);
+
+            /* Show error message if necessary: */
+            if (!comProgress.isOk() || comProgress.GetResultCode() != 0)
+            {
+                /// @todo add real error message
+                //msgCenter().cannotAcquireExportLaunchDescriptionForm(comProgress, this);
+                return false;
+            }
+            else
+                m_comVSDForm = comForm;
+        }
+        return true;
+    }
+    else
+    {
+        /* Get import appliance widget: */
+        ImportAppliancePointer pImportApplianceWidget = field("applianceWidget").value<ImportAppliancePointer>();
+        AssertMsg(!pImportApplianceWidget.isNull(), ("Appliance Widget is not set!\n"));
+
+        /* If file name was changed: */
+        if (m_pFileSelector->isModified())
+        {
+            /* Check if set file contains valid appliance: */
+            if (!pImportApplianceWidget->setFile(m_pFileSelector->path()))
+                return false;
+            /* Reset the modified bit afterwards: */
+            m_pFileSelector->resetModified();
+        }
+
+        /* If we have a valid ovf proceed to the appliance settings page: */
+        return pImportApplianceWidget->isValid();
+    }
 }
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/importappliance/UIWizardImportAppPageBasic1.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/importappliance/UIWizardImportAppPageBasic1.h	(revision 78126)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/importappliance/UIWizardImportAppPageBasic1.h	(revision 78127)
@@ -32,4 +32,5 @@
 #include "CCloudProvider.h"
 #include "CCloudProviderManager.h"
+#include "CVirtualSystemDescriptionForm.h"
 
 /* Forward declarations: */
@@ -98,6 +99,6 @@
     /** Returns Cloud Profile object. */
     CCloudProfile profile() const;
-    /** Returns Cloud Client object. */
-    CCloudClient client() const;
+    /** Returns Virtual System Description Form object. */
+    CVirtualSystemDescriptionForm vsdForm() const;
 
     /** Holds whether default source should be Import from OCI. */
@@ -105,11 +106,13 @@
 
     /** Holds the Cloud Provider Manager reference. */
-    CCloudProviderManager  m_comCloudProviderManager;
+    CCloudProviderManager          m_comCloudProviderManager;
     /** Holds the Cloud Provider object reference. */
-    CCloudProvider         m_comCloudProvider;
+    CCloudProvider                 m_comCloudProvider;
     /** Holds the Cloud Profile object reference. */
-    CCloudProfile          m_comCloudProfile;
+    CCloudProfile                  m_comCloudProfile;
     /** Holds the Cloud Client object reference. */
-    CCloudClient           m_comCloudClient;
+    CCloudClient                   m_comCloudClient;
+    /** Holds the Virtual System Description Form object reference. */
+    CVirtualSystemDescriptionForm  m_comVSDForm;
 
     /** Holds the source layout instance. */
@@ -149,5 +152,5 @@
     Q_PROPERTY(bool isSourceCloudOne READ isSourceCloudOne);
     Q_PROPERTY(CCloudProfile profile READ profile);
-    Q_PROPERTY(CCloudClient client READ client);
+    Q_PROPERTY(CVirtualSystemDescriptionForm vsdForm READ vsdForm);
 
 public: