Index: trunk/src/VBox/Frontends/VirtualBox/Makefile.kmk
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/Makefile.kmk	(revision 78127)
+++ trunk/src/VBox/Frontends/VirtualBox/Makefile.kmk	(revision 78128)
@@ -685,4 +685,5 @@
 	src/wizards/exportappliance/UIWizardExportAppPageExpert.h \
 	src/wizards/importappliance/UIApplianceUnverifiedCertificateViewer.h \
+	src/wizards/importappliance/UIFormEditorWidget.h \
 	src/wizards/importappliance/UIWizardImportApp.h \
 	src/wizards/importappliance/UIWizardImportAppPageBasic1.h \
@@ -940,4 +941,5 @@
 	src/widgets/UITabBar.cpp \
 	src/widgets/graphics/UIGraphicsScrollBar.cpp \
+	src/wizards/importappliance/UIFormEditorWidget.cpp \
 	src/wizards/importappliance/UIWizardImportApp.cpp
 
@@ -1113,4 +1115,5 @@
 	src/wizards/exportappliance/UIWizardExportAppPageExpert.cpp \
 	src/wizards/importappliance/UIApplianceUnverifiedCertificateViewer.cpp \
+	src/wizards/importappliance/UIFormEditorWidget.cpp \
 	src/wizards/importappliance/UIWizardImportApp.cpp \
 	src/wizards/importappliance/UIWizardImportAppPageBasic1.cpp \
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/importappliance/UIFormEditorWidget.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/importappliance/UIFormEditorWidget.cpp	(revision 78128)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/importappliance/UIFormEditorWidget.cpp	(revision 78128)
@@ -0,0 +1,113 @@
+/* $Id$ */
+/** @file
+ * VBox Qt GUI - UIFormEditorWidget class implementation.
+ */
+
+/*
+ * Copyright (C) 2019 Oracle Corporation
+ *
+ * This file is part of VirtualBox Open Source Edition (OSE), as
+ * available from http://www.virtualbox.org. This file is free software;
+ * you can redistribute it and/or modify it under the terms of the GNU
+ * General Public License (GPL) as published by the Free Software
+ * Foundation, in version 2 as it comes in the "COPYING" file of the
+ * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+ * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
+ */
+
+/* Qt includes: */
+#include <QComboBox>
+#include <QHeaderView>
+#include <QItemEditorFactory>
+#include <QStyledItemDelegate>
+#include <QVBoxLayout>
+
+/* GUI includes: */
+#include "QITableView.h"
+#include "UIFormEditorWidget.h"
+#include "UIMessageCenter.h"
+
+/* COM includes: */
+#include "CBooleanFormValue.h"
+#include "CChoiceFormValue.h"
+#include "CFormValue.h"
+#include "CStringFormValue.h"
+#include "CVirtualSystemDescriptionForm.h"
+
+
+/** QITableView extension used as Form Editor table-view. */
+class UIFormEditorView : public QITableView
+{
+    Q_OBJECT;
+
+public:
+
+    /** Constructs Form Editor table-view. */
+    UIFormEditorView(QWidget *pParent = 0);
+
+protected:
+
+    /** Returns the number of children. */
+    virtual int childCount() const /* override */;
+    /** Returns the child item with @a iIndex. */
+    virtual QITableViewRow *childItem(int iIndex) const /* override */;
+};
+
+
+/*********************************************************************************************************************************
+*   Class UIFormEditorView implementation.                                                                                       *
+*********************************************************************************************************************************/
+
+UIFormEditorView::UIFormEditorView(QWidget * /* pParent = 0 */)
+{
+}
+
+int UIFormEditorView::childCount() const
+{
+    /* No model => no children: */
+    return 0;
+}
+
+QITableViewRow *UIFormEditorView::childItem(int iIndex) const
+{
+    Q_UNUSED(iIndex);
+
+    /* No model => no children: */
+    return 0;
+}
+
+
+/*********************************************************************************************************************************
+*   Class UIFormEditorWidget implementation.                                                                                     *
+*********************************************************************************************************************************/
+
+UIFormEditorWidget::UIFormEditorWidget(QWidget *pParent /* = 0 */)
+    : QWidget(pParent)
+    , m_pTableView(0)
+{
+    prepare();
+}
+
+void UIFormEditorWidget::prepare()
+{
+    /* Create layout: */
+    QVBoxLayout *pLayout = new QVBoxLayout(this);
+    if (pLayout)
+    {
+        /* Create view: */
+        m_pTableView = new UIFormEditorView(this);
+        if (m_pTableView)
+        {
+            m_pTableView->setTabKeyNavigation(false);
+            m_pTableView->verticalHeader()->hide();
+            m_pTableView->verticalHeader()->setDefaultSectionSize((int)(m_pTableView->verticalHeader()->minimumSectionSize() * 1.33));
+            m_pTableView->setSelectionMode(QAbstractItemView::SingleSelection);
+
+            /* Add into layout: */
+            pLayout->addWidget(m_pTableView);
+        }
+    }
+}
+
+
+#include "UIFormEditorWidget.moc"
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/importappliance/UIFormEditorWidget.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/importappliance/UIFormEditorWidget.h	(revision 78128)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/importappliance/UIFormEditorWidget.h	(revision 78128)
@@ -0,0 +1,54 @@
+/* $Id$ */
+/** @file
+ * VBox Qt GUI - UIFormEditorWidget class declaration.
+ */
+
+/*
+ * Copyright (C) 2019 Oracle Corporation
+ *
+ * This file is part of VirtualBox Open Source Edition (OSE), as
+ * available from http://www.virtualbox.org. This file is free software;
+ * you can redistribute it and/or modify it under the terms of the GNU
+ * General Public License (GPL) as published by the Free Software
+ * Foundation, in version 2 as it comes in the "COPYING" file of the
+ * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+ * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
+ */
+
+#ifndef FEQT_INCLUDED_SRC_wizards_importappliance_UIFormEditorWidget_h
+#define FEQT_INCLUDED_SRC_wizards_importappliance_UIFormEditorWidget_h
+#ifndef RT_WITHOUT_PRAGMA_ONCE
+# pragma once
+#endif
+
+/* Qt includes: */
+#include <QWidget>
+
+/* Forward declarations: */
+class UIFormEditorView;
+
+
+/** QWidget subclass representing model/view Form Editor widget. */
+class UIFormEditorWidget : public QWidget
+{
+    Q_OBJECT;
+
+public:
+
+    /** Constructs Form Editor widget passing @a pParent to the base-class. */
+    UIFormEditorWidget(QWidget *pParent = 0);
+
+private:
+
+    /** Prepares all. */
+    void prepare();
+
+    /** Holds the table-view instance. */
+    UIFormEditorView  *m_pTableView;
+};
+
+/** Safe pointer to Form Editor widget. */
+typedef QPointer<UIFormEditorWidget> UIFormEditorWidgetPointer;
+
+
+#endif /* !FEQT_INCLUDED_SRC_wizards_importappliance_UIFormEditorWidget_h */
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/importappliance/UIWizardImportAppPageBasic2.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/importappliance/UIWizardImportAppPageBasic2.cpp	(revision 78127)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/importappliance/UIWizardImportAppPageBasic2.cpp	(revision 78128)
@@ -70,4 +70,14 @@
         }
 
+        /* Create form editor widget: */
+        m_pFormEditor = new UIFormEditorWidget(this);
+        if (m_pFormEditor)
+        {
+            m_pFormEditor->hide();
+
+            /* Add into layout: */
+            pMainLayout->addWidget(m_pFormEditor);
+        }
+
         /* Create certificate label: */
         m_pCertLabel = new QLabel("<cert label>", this);
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/importappliance/UIWizardImportAppPageBasic2.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/importappliance/UIWizardImportAppPageBasic2.h	(revision 78127)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/importappliance/UIWizardImportAppPageBasic2.h	(revision 78128)
@@ -23,4 +23,5 @@
 
 /* GUI includes: */
+#include "UIFormEditorWidget.h"
 #include "UIWizardImportAppDefs.h"
 #include "UIWizardPage.h"
@@ -42,5 +43,7 @@
 
     /** Holds the appliance widget instance. */
-    ImportAppliancePointer m_pApplianceWidget;
+    ImportAppliancePointer     m_pApplianceWidget;
+    /** Holds the Form Editor widget instance. */
+    UIFormEditorWidgetPointer  m_pFormEditor;
 };
 